from pyplanet.views.generics.widget import TemplateView
import json


class ChatView(TemplateView):
	template_name = 'emotes/customchat.xml'

	def __init__(self, app, *args, **kwargs):
		super().__init__(*args, **kwargs)
		self.app = app
		self.manager = app.context.ui
		self.id = 'pyplanet__widgets_chat'

	async def get_context_data(self):
		context = await super().get_context_data()
		context.update({
			'emote_data': await self.app.setting_emote_data.get_value(),
			'emote_url': await self.app.setting_emote_url.get_value(),
		})
		return context


class ChatUpdaterView(TemplateView):
	template_name = 'emotes/updater.xml'

	def __init__(self, app, *args, **kwargs):
		super().__init__(*args, **kwargs)
		self.app = app
		self.manager = app.context.ui
		self.id = 'emotes__updater'

	async def get_player_data(self):
		data = await super().get_player_data()
		for player in self.app.instance.player_manager.online:
			data[player.login] = dict(chat=json.dumps(self.app.player_chats[player.login][::-1]))
		return data

	async def display(self, **kwargs):
		return await super().display(**kwargs)

	# async def get_context_data(self):
	#	context = await super().get_context_data()
	#	context.update({
	#		'chat': json.dumps(self.app.chatlines)
	#	})
	# 	return context
